<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { inject, ref } from 'vue';
import { useI18n } from 'vue-i18n';
import { storeToRefs } from 'pinia';
import Modal from '@/components/general/Modal.vue';
import { useMetaStore } from '@/stores/meta';
import PasswordField from '@/components/general/form/PasswordField.vue';
import Checkbox from '@/components/general/form/Checkbox.vue';
import { request } from '@/lib/request';
import Input from '@/components/general/form/Input.vue';
import { adminMenuEnum } from '@/enums/enums';

const { t } = useI18n();
const $t = t; 

let configuration = inject<any>('configuration');

const store = useMetaStore();
const { hashcode, paneType, getHeadline, openMenu } = storeToRefs(store);

const emits = defineEmits<{
    (e: 'close', value: boolean): void
}>();

const name = ref($t('general.variables.copy') + ' ' + getHeadline.value);
const aPassword = ref('');
const aPasswordValid = ref(true);
const uPassword = ref('');
const uPasswordValid = ref(true);
const copyLikes = ref(true);

const isConfirmationOpen = ref(false);
const newURL = ref('');
const isErrorOpen = ref(false);

const handleClose = ()=>{
    //emits('close', false);
    openMenu.value = adminMenuEnum.NONE;
    aPassword.value = '';
    uPassword.value = '';
    aPasswordValid.value = true;
    uPasswordValid.value = true;
    copyLikes.value = true;
    newURL.value = '';
    isConfirmationOpen.value = false;
    isErrorOpen.value = false;
}

const handleSubmit = async ()=>{
    if(aPasswordValid.value && uPasswordValid.value){
        let params = {
            hashcode: hashcode.value,
            userPassword: uPassword.value,
            adminPassword: aPassword.value,
            copyLikes: copyLikes.value,
            headline: name.value
        };
        try{
            let result = await request('POST', configuration.apiServer+"/api/"+paneType.value+"/copy/", params, 'application/json', false, true);
            if(result && result.success){
                newURL.value = configuration.baseURL+configuration.basePath+"a/"+result.hashcode;
                isConfirmationOpen.value = true;
                return;
            }
        }catch(error){
            console.error(error);
        }
        isErrorOpen.value = true;
    }
}

</script>
<template>
<Modal :header="$t('adminMenu.copy.forMe.title')" @cancel="handleClose" :labelCancel="$t('general.buttons.cancel')" :disableSubmit="!(((aPassword && aPassword.length>=8 && aPasswordValid) 
        && (uPassword && uPassword.length>=6 && uPasswordValid))
        ||(aPassword && aPassword.length>=8 && aPasswordValid && !uPassword) 
        || (uPassword && uPassword.length>=6 && uPasswordValid && !aPassword) || (!aPassword && !uPassword))" @submit="handleSubmit" :labelSubmit="$t('adminMenu.copy.label')">
    <div><Input :label="$t('contentPage.post.headline')" :placeholder="$t('contentPage.post.headline')" v-model="name" type="text" autocomplete="one-time-code"/></div>
    <div class="flex flex-row gap-2 px-px">
        <div class="w-full">
            <PasswordField v-model="aPassword" v-model:valid="aPasswordValid" :strong="true" :error-text="$t('adminMenu.passwordReset.error.password.strong')" :label="$t('general.variables.password.sg')+' ('+$t('indexPage.buttonTexts.login.tabs.mod')+')'"/>
        </div>
        <div class="w-full">
            <PasswordField v-model="uPassword" v-model:valid="uPasswordValid" :strong="false" :error-text="$t('adminMenu.passwordReset.error.password.user')" :label="$t('general.variables.password.sg')+' ('+$t('indexPage.buttonTexts.login.tabs.user')+')'"/>
        </div>
    </div>
    <Checkbox v-model="copyLikes" :label="$t('adminMenu.copy.forMe.copyLikes')"/>
    <p class="mt-2">{{$t('adminMenu.copy.forMe.hint')}}</p>
    <Modal v-if="isConfirmationOpen" :header="$t('adminMenu.copy.forMe.claimed.submit')" :labelSubmit="$t('adminMenu.copy.forMe.claimed.closeConfirmation')" @submit="handleClose" :text="$t('adminMenu.copy.forMe.claimed.confirmation', {NEWURL: newURL})"></Modal>
    <Modal v-if="isErrorOpen" :header="$t('adminMenu.copy.error')" :labelSubmit="$t('adminMenu.copy.forMe.claimed.closeConfirmation')" @submit="handleClose" :text="$t('adminMenu.copy.forMe.claimed.error')"></Modal>
</Modal>
</template>